/*
	OPRICEANA Cristina - Georgiana - 332 CA
	
	Detector de prezenta
*/


#define DIST_SENSOR    0
#define ANALOGIC_SENSOR 1

#include "headers.h"
int init = 0;

int layers[4] = {LAYER1, LAYER2, LAYER3, LAYER4};
int layer[16] = {
	PA7, PA6, PA5, PA4,
	PA3, PA2, PA1, PA0,
	PC4, PC5, PC6, PC7,
	PD6, PC1, PC2, PC3
	};
int vx[4];

/* melodia curenta */
int current_id;
int *current_melody;
int *current_duration;
uint16_t current_size;
int16_t this_duration;
int model_layer;

/* iterez prin vectorul de note */
unsigned int k = 1;

/* pentru modele */
int inner, outer;


void IO_init(void) {
	
	DDRA |= 0xff;
	DDRC |= 0xff;

	/* PC0 ca intrare */
	DDRC &= ~(1 << PC0);
	PORTC |= (1 << PC0);
	
	DDRD |= (1 << PD0); // PD0 ca iesire
	PORTD &= ~(1 << PD0);    // LED ON
	
	
	/* prima melodie va fi starwars */
	current_id = 0;
	current_melody = starwars;
	current_duration = starwars_duration;
	current_size = sizeof(starwars) / sizeof(int);
}

//----------------------------------------------AUDIO

/* initializeaza timer-ul 1 */
void timer1_init() {
    /* Fast PWM cu prag pe ICR1 si prescaler 1024 */
    TCCR1B |= (1 << CS10) | (1 << WGM13) | (1 << WGM12);
    TCCR1A |= (1 << WGM11);

	TCCR1A |= (1 << COM1B1);
	TCCR1A |= (1 << COM1A1);
	TCCR1A &= ~(1 << COM1B0);

	/* output pe PD5 */
	DDRD |= (1 << PD5);
	
	DDRD &= ~(1 << PD4); // PD4 este input

    /* modul curent numara pana la ICR1 */
    ICR1 = 16000000 / current_melody[0];
    /* duty cycle-ul este setat initial la 25% */
    OCR1B = ICR1 / 4;
    /* duty cycle-ul pentru speaker (OC1A) este la 50% */
    OCR1A = ICR1 / 2;
}

/* alege noua melodie */
void choose_melody(void) {
	current_id = (current_id + 1) % 3;
	
	switch(current_id) {
		case STARWARS:
			current_melody = starwars;
			current_duration = starwars_duration;
			current_size = sizeof(starwars) / sizeof(int);
			break;
		case MAINTHEME:
			current_melody = maintheme;
			current_duration = maintheme_duration;
			current_size = sizeof(maintheme) / sizeof(int);
			break;
		case UNDERWORLD:
			current_melody = underworld;
			current_duration = underworld_duration;
			current_size = sizeof(underworld) / sizeof(int);
			break;
	}
}

//---------------------------------------------------------

void ADC_init(void) {

	ADMUX = (1 << REFS0);
	ADCSRA = (1 << ADEN) | (7 << ADPS0);
}

int ADC_get(uint8_t channel) {

	ADMUX = (ADMUX & ~(0x1F << MUX0)) | channel;
	
	ADCSRA |= (1 << ADSC);
	
	while (ADCSRA & (1 << ADSC));
	
	return ADC;
}

void ADC_show(void) {

	int i, sensors[2];
	
	/* clear the LCD screen */
	_delay_ms(500);
	
	/* get values */
	for (i = 0; i < 2; i++) {
		sensors[i] = ADC_get(i);
	}
	

	 
	if (sensors[0] == 0) {
	
			if (init == 0) {
					/* pornesc redarea audio */
					timer1_init();
					sei();

					init = 1;
				}
				/*else {
				
					function_redare();
					choose_melody();
				}*/

	} else if (sensors[0] > 0 && sensors[0] <= 10) {
	
	
			if (init == 0) {
					/* pornesc redarea audio */
					timer1_init();
					sei();

					init = 1;
				}
				/*else {
				
					choose_melody();
				}*/

	
	} else {
	
			if (init == 0) {
					/* pornesc redarea audio */
					timer1_init();
					sei();

					init = 1;
				}
				/*else {
				
					choose_melody();
				}*/

		
	}
	
}


void function_redare(){

			
			/* in functie de ICR1 canta notele */
			ICR1 = F_CPU / current_melody[k];
			OCR1A = ICR1 / 2;
			OCR1B = ICR1 / 4;
			
			this_duration = current_duration[k] * 1.3;

			_delay_ms(this_duration);
			k++;
			if (k == current_size) {
				k = 0;
			}	

}


/* main */
int main (void)
{
	IO_init();	
	
	_delay_ms(2000);
	
	ADC_init();
	//ADC_show();
		
	while (1) {

			
			
			if (!(PIND & (1 << PD4))){
			
				
				if (init == 0) {
					/* pornesc redarea audio */
					timer1_init();
					sei();

					init = 1;
					
					
					PORTD ^= (1 << PD0);
					
				}
			}
			
			if( init )
				PORTD ^= (1 << PD0);

			ICR1 = F_CPU / current_melody[k];
			OCR1A = ICR1 / 2;
			OCR1B = ICR1 / 4;
			


			this_duration = current_duration[k] * 1.3;

			_delay_ms(this_duration);
			k++;
			if (k == current_size) {
				k = 0;
			}
			
			if( init)
				function_redare();
		
			
			/* la apasarea pe buton se schimba melodiile */
			if ((PINC & (1 << PC0)) == 0) {
				
				if (init == 0) {
				
					timer1_init();
					sei();

					init = 1;
				}
				else {
					k =0;
					choose_melody();
				}
					
			}
			
		}
	return 0;
}